"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSchema = void 0;
var schema_1 = require("@graphql-tools/schema");
var load_files_1 = require("@graphql-tools/load-files");
var merge_1 = require("@graphql-tools/merge");
var IS_CODEGEN = process.argv.join(' ').includes('codegen');
var lodash_1 = require("lodash");
function createSchema(config) {
    config.typeDefs = (config === null || config === void 0 ? void 0 : config.typeDefs) || [];
    if (config.loadFiles) {
        var SchemaFiles = (0, load_files_1.loadFilesSync)(process.cwd() + '/src/**/*.graphql', {});
        config.typeDefs = config.typeDefs.concat((0, merge_1.mergeTypeDefs)(SchemaFiles, { commentDescriptions: true }));
    }
    config.typeDefs = (0, merge_1.mergeTypeDefs)((config === null || config === void 0 ? void 0 : config.typeDefs) || [], { commentDescriptions: true });
    config = (0, lodash_1.merge)({
        parseOptions: {
            commentDescriptions: true,
        },
        resolverValidationOptions: {
            requireResolversToMatchSchema: IS_CODEGEN ? 'ignore' : 'warn',
        }
    }, config);
    var schema = (0, schema_1.makeExecutableSchema)(config);
    for (var _i = 0, _a = ((config === null || config === void 0 ? void 0 : config.directives) || []); _i < _a.length; _i++) {
        var directive = _a[_i];
        schema = directive.apply(schema);
    }
    return schema;
}
exports.createSchema = createSchema;
